# Generated by Django 4.0.2 on 2022-02-24 13:51

import uuid

import django.core.serializers.json
import django.db.models.deletion
import django.utils.timezone
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="ZapierToken",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "api_token",
                    models.UUIDField(
                        default=uuid.uuid4,
                        help_text="API token for use in Zapier integration",
                    ),
                ),
                (
                    "api_scopes",
                    models.JSONField(
                        blank=True,
                        default=list,
                        help_text="List of strings used to define access permissions.",
                    ),
                ),
                ("created_at", models.DateTimeField(default=django.utils.timezone.now)),
                ("last_updated_at", models.DateTimeField()),
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="zapier_token",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ZapierTokenRequest",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("scope", models.CharField(max_length=50)),
                ("timestamp", models.DateTimeField(default=django.utils.timezone.now)),
                (
                    "data",
                    models.JSONField(
                        blank=True,
                        default=list,
                        encoder=django.core.serializers.json.DjangoJSONEncoder,
                        help_text="The JSON response sent to Zapier.",
                    ),
                ),
                (
                    "count",
                    models.IntegerField(
                        default=0,
                        help_text="Denormalised object count, used for filtering",
                    ),
                ),
                (
                    "token",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="requests",
                        to="zapier.zapiertoken",
                    ),
                ),
            ],
            options={
                "ordering": ("timestamp",),
                "get_latest_by": "timestamp",
            },
        ),
    ]
